function err = MosaicError(x, measurements, order, W0, w, N)

A = x(1);
B = x(2);
C = x(3);

order2 = order(1);
order3 = order(2);
order4 = order(3);

spectrum = measurements(1, :);
Smin = measurements(2, :);
Smax = measurements(3, :);


                phaseWk = A*order2*(w-W0).^2 + B*order3*(w-W0).^3 + C*order4*(w-W0).^4;
                
                Spectrum = (abs(spectrum)).^.5; %o.o. spectrum
                
                pulseF = Spectrum.*exp(i.*phaseWk); %pulse fourier domain
                
                pulseT = fftshift(ifft(pulseF)); %pulse time domain
                
                Iten = pulseT.* conj(pulseT);
                Iten2 = pulseT.* pulseT;
                
                Iten = Iten/max(abs(Iten));
                Iten2 = Iten2/max(abs(Iten2));   
	
                A0 = xcorr(Iten);

                A2 = xcorr(Iten2);
                A0 = A0/real(max(A0));
                A2 = A2/abs(max(A2));
                                
                csmin = A0 - abs(A2);
                Csmin = csmin(N/2+1:3*N/2);
                A0 = A0(N/2+1:3*N/2);
                
                err = (Csmin-Smin).^2 + (A0-Smax).^2;
            
                err = (sum(err)/(2*N)).^.5;